import React, { useState, useRef, useEffect } from 'react';
import { Card, Select, Button, message, Checkbox, Modal } from 'antd';
import { BetaSchemaForm, ProFormList, ProForm } from '@ant-design/pro-form';
import ProTable from '@ant-design/pro-table';
import { ProCard } from '@ant-design/pro-Card';
// import { ProFormList } from '@ant-design/pro-list';
import style from '../style.less'
import { CloseOutlined } from '@ant-design/icons';
import {
    AddGoodsTechnologyAction
} from '../service';
import { useFetchData } from '@ant-design/pro-utils';
const EditCarTable = (props) => {
    const [chnologyId, settechnologyid] = useState('')
    const [modalVisible, setmodalVisible] = useState(false)
    const [selectedRowKeys, setselectedRowKeys] = useState([])
    const [editdata, seteditdata] = useState({})
    //选中的行
    const [selectedRowsState, setSelectedRows] = useState([]);
    const [disabled, setdisabled] = useState(false)
    const [batchingdata, setbatchingdata] = useState([])
    const [sort, setsort] = useState(0)
    const [option, setoption] = useState({})
    //const [batchingcheckdata, setbatchingcheckdata] = useState([])
    // const [isBatch, setisBatch] = useState()
    const formRef = useRef();
    const actionRef = useRef();
    const modelval = useRef(false);
    const batchingcheckdata = useRef([]);
    //const checkchnologyId = useRef();
    useEffect(() => {
        if (Object.keys(props.technologyattrdata).length > 0) {
            if (props.technologyattrdata.attributes.length > 0) {
                seteditdata(props.technologyattrdata.attributes[0]);
                setdisabled(true);
                modelval.current = false;
            }
        }
        formRef.current?.setFieldsValue(props.technologyattrdata)
        setbatchingdata(props.batchingdata)
        op()
    }, [props.technologyattrdata, props.batchingdata,props.goodstechnologydata])
    const [technologyname, settechnologyname] = useState('')
    const tablecolumns = [
        {
            title: '主键',
            dataIndex: 'id',
            tip: '规则名称是唯一的 key',
            hideInSearch: true,
            hideInTable: true,
            render: (dom, entity) => {
                return (
                    <a
                        onClick={() => {
                            // setCurrentRow(entity);
                            // setShowDetail(true);
                        }}
                    >
                        {dom}
                    </a>
                );
            },
        },
        {
            title: '名称',
            dataIndex: 'name',
            valueType: 'textarea',
            ellipsis: true,
            search: false,
        },
    ]
    const columns = [
        {
            // key:sort,
            dataIndex: 'chnologyId',
            valueType: 'select',
            valueEnum:option,
            // fieldProps:{
            //     onChange:()=>{onchangesel}
            // }
        },
        {
            key:sort,
            valueType: 'dependency',
            name: ['chnologyId'],
            columns: ({ chnologyId }) => {
                debugger
                var cloumdata = [];
                console.log("chnologyId",chnologyId);
                if (chnologyId) {
                    var fg=chnologyId.split(':');
                    let isBatch=fg[1]
                    let cid=fg[0]
                    var sd = props.technologyattralldata.filter(x => x.goodstechnologyId == cid);
                    console.log(isBatch)
                    console.log("更新数据")
                    settechnologyname(fg[2])
                    if(isBatch=="true"){
                        console.log("非液体料更新")
                        if (sd.length > 0) {
                            modelval.current=false;
                            sd.map((x, index) => {
                                var options = {}

                                // //工序添加
                                //  //生成唯一索引
                                //  var key=0;
                                //  if(cloumdata.length==0)
                                //  {
                                //     key=1;
                                //  }
                                //  else
                                //  {
                                //     cloumdata.forEach(x=>{
                                //         if(x.key)
                                //         {

                                //         }
                                //     })
                                //  }
                                //  cloumdata.find(x=>x.index)

                                let columnspro =
                                {
                                    
                                    title: () => { return <span className={style['formlable']}>{x.actionName}</span> },
                                    dataIndex: "actionvalue-" + x.id + ":" + x.actionName,
                                    valueType: x.actionType,
                                    width: 'md',
                                 //   key:
                                }
                                if (x.actionType == "select") {
                                    if (x.actionValue) {
                                        var va = JSON.parse(x.actionValue);
                                        for (let i = 0; i < va.length; i++) {
                                            var op = { text: va[i].actionValueName };
                                            options[va[i].actionValueName] = op
                                        }
                                        columnspro.valueEnum = options;
                                    }
                                }
                                cloumdata.push(columnspro)
                                
                            })
                        } 
                    }else {
                        //setmodalVisible(true)
                        console.log("液体料更新")
                        console.log(modelval.current)
                        let ajs = []
                        if (!modelval.current) {
                            setmodalVisible(true)
                        } else {
                            
                            if (Object.keys(editdata).length == 0) {
                                ajs = selectedRowsState
                            } else {
                                const keys = Object.keys(editdata);
                                var sd = keys.filter(x => x !== "chnologyId" && x !== "id" && x !== "sort" && x !== "name");
                                sd.map(x => {
                                    var va = x.replace("actionvalue-", "").split(':')
                                    ajs.push({ id: va[0], name: va[1], ischeck: true });
                                })
                            }
                            console.log("ajs",ajs)
                            ajs.map((x,index)=> {
                                let columnspro =
                                {
                                    key:sort+"-"+index,
                                    title: x.name,// checkbox(x.ischeck, x.id,x.name),
                                    dataIndex: "actionvalue-" + x.id + ":" + x.name,
                                    valueType: 'text',
                                    width: 'md',
                                    initialValue: 0
                                }
                                cloumdata.push(columnspro)
                            })
                        }

                   }
                }
                return cloumdata
            }
        }
    ]
    const op=()=>{
        var options = {}
        for (let i = 0; i <  props.goodstechnologydata.length; i++) {
            var op = { text: props.goodstechnologydata[i].label };
            options[props.goodstechnologydata[i].value+":"+props.goodstechnologydata[i].isBatch+":"+props.goodstechnologydata[i].label] = op
        }
        setoption(options)
    }
    const onchangesel=(val)=>{
        console.log("1111111111111111111111111")
        console.log(val)
    }
    const onHandleChange = (value, option) => {
        //setisBatch(option.isBatch)
        if(!option.isBatch){
            modelval.current=false
        }
        settechnologyid(value)
        settechnologyname(option.label)
    }
    const getFormatValues = () => {
        let check = true;
        let arr = formRef.current?.getFieldsFormatValue?.()
        let data = []
        for (let index = 0; index < arr.attributes.length; index++) {
            const element = arr.attributes[index];
            let item = {};
            item.id = element.id
            item.stepName = props.goodstechnologydata.find(x => x.value == element.chnologyId)?.label;
            item.chnologyId = element.chnologyId;
            if (element.chnologyId == "") {
                check = false;
            }
            let ajs = []
            const keys = Object.keys(element);
            //const values = Object.values(element); 
            var sd = keys.filter(x => x !== "chnologyId" && x !== "id" && x !== "sort" && x !== "name");
            sd.map(x => {
                var va = x.replace("actionvalue-", "").split(':')
                batchingcheckdata.current.map(p => {
                    if (p.id == va[0]) {
                        ajs.push({ actionName: va[1], actionValue: element[x], technologyactionId: va[0] });
                    }
                })
                //ajs.push({ actionName: va[1], actionValue: element[x], technologyactionId: va[0] });

            })
            if (ajs.length == 0) {
                check = false;
            }

            item.actionJson = JSON.stringify(ajs);
            item.sort = element.sort == undefined ? props.maxsort + (index + 1) : element.sort;
            item.goodsId = props.goodsid;
            item.goodsAttributeId = props.checkvalue.join(',')

            data.push(item);
        }
        console.log(
            '保存的数据：',
            data,
        );
        if (data.length > 0 && check) {
            AddGoodsTechnologyAction(data).then((res) => {
                if (res.data) {
                    message.success("保存成功")
                    setSelectedRows([])
                    formRef?.current?.resetFields()
                    seteditdata({});
                    setdisabled(false);
                    batchingcheckdata.current = []
                    props.updadata()
                } else {
                    message.error("保存失败")
                }
            })

        } else {
            message.error("没有要保存的数据或数据格式不正确")
        }
    };

    return (
        <div>
            <ProForm
                layout="horizontal"
                formRef={formRef}
                submitter={{
                    submitButtonProps: {
                        style: {
                            // 隐藏重置按钮
                            display: 'none',
                        },
                    },
                    render: (props, doms) => {
                        return [
                            ...doms,
                            <Button htmlType="button" onClick={getFormatValues} key="format">
                                保存
                            </Button>,
                        ];
                    },
                }}
            >
                <ProFormList
                    name="attributes"
                    creatorButtonProps={{ creatorButtonText: '添加工艺', }}
                    copyIconProps={false}
                    initialValue={props.technologyattrdata}
                    actionGuard={{
                        beforeAddRow: async (defaultValue, insertIndex) => {
                            if (Object.keys(editdata).length > 0) {
                                message.error("当前处于编辑状态无法新增，删除当前编辑工艺后在新增");
                                return false;
                            } else {
                               //setSelectedRows([])
                                batchingcheckdata.current = []
                                if(sort==0){
                                    setsort(props.maxsort+1)
                                }else{
                                    setsort(sort+1)
                                }
                             
                                return true;
                            }

                        },
                        beforeRemoveRow: async (index) => {
                            seteditdata({})
                            batchingcheckdata.current = []
                            //setdisabled(false);
                            return true;
                        },
                    }}
                    itemRender={({ listDom, action }, { record, index }) => (
                        <ProCard title={"工序号" + (record.sort == undefined ? (props.maxsort + (index + 1)) : record.sort)} bordered extra={action} bodyStyle={{ padding: 15 }} headStyle={{ padding: '0px 24px' }} style={{ marginBlockEnd: 8 }}>
                            {listDom}
                        </ProCard>
                    )}
                    creatorRecord={{ chnologyId: '' }}
                >
                    {/* <ProForm.Item name="chnologyId" style={{ float: 'left' }}>
                        <Select name="chnologyId" key={sort} style={{ width: '90px' }} disabled={disabled} options={props.goodstechnologydata} onChange={async (value, option) => { onHandleChange(value, option) }}></Select>
                    </ProForm.Item> */}
                    <ProForm.Item isListField name="items" style={{ float: 'left', width: '75%' }}>
                        <BetaSchemaForm
                            layoutType="Embed"
                            type="custom"
                            shouldUpdate={false}
                            formItemProps={{
                                forceRender: false,
                                labelAlign: 'left',
                            }}
                            columns={columns}

                        />
                    </ProForm.Item>
                </ProFormList>
            </ProForm>
            <Modal
                title={'动作配置'}
                width={640}
                visible={modalVisible}
                bodyStyle={{ padding: '32px 40px 1px 48px' }}
                focusTriggerAfterClose={false}
                onCancel={() => {
                    modelval.current = true;
                    setmodalVisible(false)
                    setSelectedRows([])
                }}
                onOk={() => {
                    modelval.current = true;
                    setmodalVisible(false)
                }}
                // destroyOnClose
                maskClosable={false}
            >
                <ProTable
                    headerTitle="物料列表"
                    rowKey="id"
                    actionRef={actionRef}
                    search={{
                        labelWidth: 120,
                    }}
                    columns={tablecolumns}
                    request={(params) => {
                        let name = '';
                        let ajs = [];
                        if (!technologyname) {
                            name = props.technologyattrdata.attributes[0].name;
                            const keys = Object.keys(props.technologyattrdata.attributes[0]);
                            var sd = keys.filter(x => x !== "chnologyId" && x !== "id" && x !== "sort" && x !== "name");
                            sd.map(x => {
                                var va = x.replace("actionvalue-", "").split(':')
                                ajs.push({ id: va[0], name: va[1] });
                            })

                        } else {
                            name = technologyname;
                        }
                        console.log("已选中的数据：", ajs)
                        var dataSource = props.batchingdata.filter(x => x.typeName == name)
                        if (ajs.length > 0) {
                            setSelectedRows(ajs);
                            setselectedRowKeys(ajs.map(x => { return x.id }))
                        }

                        return {
                            data: dataSource,
                            success: true,
                            total: dataSource.length,
                        };
                    }}
                    // 每行选择点击事件
                    rowSelection={{
                        selectedRowKeys,
                        onSelect: (record, selected) => {
                            const tempArray = [...selectedRowKeys];
                            const tempArray1 = [];
                            const findIndex = tempArray.findIndex(item => item === record.id);
                            if (selected) {
                                findIndex < 0 && tempArray.push(record.id);
                                tempArray1.push({ id: record.id, name: record.name })
                            } else {
                                findIndex > -1 && tempArray.splice(findIndex, 1);
                            }
                            setselectedRowKeys(tempArray);
                            //setSelectedRows(tempArray1);
                        },
                        onSelectAll: (selected, selectedRows, changeRows) => {
                            const tempArray = [...selectedRowKeys];
                            if (selected) {
                                selectedRows.forEach(item => {
                                    if (!item) return;
                                    const findIndex = tempArray.findIndex(fItem => fItem === item.id);
                                    if (findIndex < 0) {
                                        tempArray.push(item.id);
                                    }
                                });
                            } else {
                                changeRows.forEach(item => {
                                    const findIndex = tempArray.findIndex(fItem => fItem === item.id);
                                    if (findIndex > -1) {
                                        tempArray.splice(findIndex, 1);
                                    }
                                });
                            }
                            setselectedRowKeys(tempArray);
                            //setSelectedRows(selectedRows)
                        },
                        onChange: (_, selectedRows) => {
                            setSelectedRows(selectedRows);
                        },
                    }}
                ></ProTable>
            </Modal>
        </div>
    );
};
export default EditCarTable;